%% apochromat design, with movie


%%

clear
load apo1
global cv th rn;


%% movie

filename = 'apo1x.avi';
aviobj = avifile(filename);
N = 21;
shape = linspace(-4,4,N);
data = zeros(length(shape),4);
for k=1:length(shape)
    v=[0 0 shape(k)];
    show_frame;
    aviobj = addframe(aviobj,getframe(gcf));
    data(k,:) = f;
end
aviobj = close(aviobj);

%% find minima in each cross-section

semilogy(shape,data(:,1));

%% 

[c idx] = min(data(:,1));
v = data(idx,2:4);
disp('starting point');
disp(v);
f = apochromat(v);
fprintf('merit function %g\n',norm(f));

%% trial 1

[xo vout hp] = cycle(v,@apochromat);
disp('solution');
disp(xo);
show_progress(hp);

%% trial 2

v = [-2 1 -0.5];
[xo vout hp] = cycle(v,@apochromat);
disp('solution');
disp(xo);
show_progress(hp);
xop = xo;

%% trial 3

v = [-0.5 1 -2];
[xo vout hp] = cycle(v,@apochromat);
disp('solution');
disp(xo);
show_progress(hp);

%% use all starting points

soln = zeros(length(shape),5);
for k=1:length(shape)
    v = data(k,2:4);
    [xo vout hp ncycles] = cycle(v,@apochromat);
    f = apochromat(xo);
    soln(k,:) = [norm(f) ncycles xo'];
    fprintf('%4d %10.4g %5d %10.4f %10.4f %10.4f\n',k,soln(k,:));
end

%% thicken the lens

f = apochromat(xop);
fprintf('merit %g\n',norm(f));
close
th(2) = 2;
th(3) = 0.5;
th(4) = 1;
th(5) = 0.1;
th(6) = 2.5;
sa = ones(size(th))*50/8;
lp = [2 4 6];
drawsys;

%% optimize thickened lens

[xo vout hp] = cycle(xop,@apochromat);
disp('solution');
disp(xo);
drawsys;
disp('lens prescription');
rd = curvature(cv);
disp([rd' th' rn(2,:)' sa']);

save apo2 cv th rn xo sa lp

%% show aberrations

yap = 50/8;
uco = tan(2.0*pi/180);
wvl = [ 0.48613 0.58756 0.65627 ];
for k=1:3
    ya = parax([yap 0],cv,th,rn(k,:));
    yc = parax([0 uco],cv,th,rn(k,:));
    fprintf('\n wavelength %g\n', wvl(k) );
    ford(ya,yc,cv,th,rn(k,:),wvl(k));
end

%%

th = th*0;







