%% generate defect maps

n=128;
u1 = linspace(-4,4,n);
u2 = linspace(-4,4,n);
map = zeros(n,n);
map1 = map;
map2 = map;
map3 = map;
for r=1:n
    v(2)=u2(r);
    for c=1:n
        v(1)=u1(c);
        f = apochromat(v);
        map(r,c)=f'*f;
        map1(r,c)=f(1);
        map2(r,c)=f(2);
        map3(r,c)=f(3);
    end
end
z = log10(map)+3;
str = sprintf('shape of third element %7.4g',v(3));

%% show zero contours

%pos = get(gcf,'Position');
%set(gcf,'Position',pos);
contour(u1,u2,map2,[0 0],'b');
axis square;
hold on;
contour(u1,u2,map3,[0 0],'r');
contour(u1,u2,map1,[0 0],'k');
hold off;
xlabel('shape of first element');
ylabel('shape of second element');
title(str);

%% find minimum

[c idx] = min(map);
[c idy] = min(c);
idx = idx(idy);
fprintf('minimum %g at %d %d\n',c,idx,idy);
v = [u1(idy) u2(idx) v(3)];
f = apochromat(v);
fprintf('minimum %g at %g %g %g\n',f'*f,v);
f = [c v];